package org.maltparser.core.dataformat.writer;

import java.io.OutputStreamWriter;

import org.maltparser.core.exception.MaltChainedException;
import org.maltparser.core.graph.DependencyGraph;

/**
 *  
 *
 * @author Johan Hall
 * @since 1.0
**/
public interface DataWriter {
	public void initialize(String fileName, String charsetName) throws MaltChainedException;
	public void initialize(OutputStreamWriter osw) throws MaltChainedException;
	public void writeProlog() throws MaltChainedException;
	public void writeSentence(DependencyGraph dependencyGraph) throws MaltChainedException;
	public void writeEpilog() throws MaltChainedException;
	public void close() throws MaltChainedException;
}
