package org.maltparser.parser.guide;

import java.io.File;
import java.io.InputStreamReader;
import java.io.OutputStreamWriter;

import org.maltparser.core.config.SingleMaltConfiguration;
import org.maltparser.core.exception.MaltChainedException;
import org.maltparser.core.graph.DependencyGraph;
import org.maltparser.core.sentence.Sentence;
import org.maltparser.parser.algorithm.ParsingAlgorithm;
import org.maltparser.parser.algorithm.helper.ParserAction;

public interface GuideModel {
	public void addInstance(ParserAction parserAction) throws MaltChainedException;
	public void finalizeSentence(Sentence sentence, DependencyGraph dependencyGraph) throws MaltChainedException;
	public void noMoreInstances() throws MaltChainedException;
	public void finalize() throws MaltChainedException;

	/* During parsing */
	public boolean predict() throws MaltChainedException;

	public SingleMaltConfiguration getConfiguration() throws MaltChainedException;
	public String getModelName() throws MaltChainedException;
	public ParsingAlgorithm getParsingAlgorithm() throws MaltChainedException;
	public int getParserMode() throws MaltChainedException;
	public OutputStreamWriter getOutputStreamWriter(String suffix) throws MaltChainedException;
	public InputStreamReader getInputStreamReader(String suffix) throws MaltChainedException;
	public File getFile(String suffix) throws MaltChainedException;
}
